SignatureScheme (Apache Tomcat 10.1.57 API Documentation)
Description: declaration: package: org.apache.tomcat.util.net.openssl.ciphers, enum: SignatureScheme

# Enum SignatureScheme

java.lang.Object
java.lang.Enum<SignatureScheme>
org.apache.tomcat.util.net.openssl.ciphers.SignatureScheme

All Implemented Interfaces:
  `Serializable, Comparable<SignatureScheme>, java.lang.constant.Constable`

public enum SignatureScheme extends Enum<SignatureScheme>
All the signature schemes for TLS 1.3.

See Also:
  - The signature schemes registry

- ## Nested Class Summary

  ### Nested classes/interfaces inherited from class Enum

  `Enum.EnumDesc<E>`

- ## Enum Constant Summary

  Enum Constants
  Enum Constant
  Description
  `ecdsa_secp256r1_sha256`
  ECDSA with P-256 and SHA-256.
  `ecdsa_secp384r1_sha384`
  ECDSA with P-384 and SHA-384.
  `ecdsa_secp521r1_sha512`
  ECDSA with P-521 and SHA-512.
  `ecdsa_sha1`
  ECDSA with SHA-1 (legacy).
  `ed25519`
  EdDSA with Ed25519.
  `ed448`
  EdDSA with Ed448.
  `mldsa44`
  ML-DSA level 2.
  `mldsa65`
  ML-DSA level 3.
  `mldsa87`
  ML-DSA level 5.
  `rsa_pkcs1_sha1`
  RSA with SHA-1 (PKCS1-v1_5, legacy).
  `rsa_pkcs1_sha256`
  RSA with SHA-256 (PKCS1-v1_5).
  `rsa_pkcs1_sha384`
  RSA with SHA-384 (PKCS1-v1_5).
  `rsa_pkcs1_sha512`
  RSA with SHA-512 (PKCS1-v1_5).
  `rsa_pss_pss_sha256`
  RSA-PSS with SHA-256.
  `rsa_pss_pss_sha384`
  RSA-PSS with SHA-384.
  `rsa_pss_pss_sha512`
  RSA-PSS with SHA-512.
  `rsa_pss_rsae_sha256`
  RSA-PSS with RSA-E and SHA-256.
  `rsa_pss_rsae_sha384`
  RSA-PSS with RSA-E and SHA-384.
  `rsa_pss_rsae_sha512`
  RSA-PSS with RSA-E and SHA-512.
  `slhdsa_sha2_128f`
  SLH-DSA SHA2-128F.
  `slhdsa_sha2_128s`
  SLH-DSA SHA2-128S.
  `slhdsa_sha2_192f`
  SLH-DSA SHA2-192F.
  `slhdsa_sha2_192s`
  SLH-DSA SHA2-192S.
  `slhdsa_sha2_256f`
  SLH-DSA SHA2-256F.
  `slhdsa_sha2_256s`
  SLH-DSA SHA2-256S.
  `slhdsa_shake_128f`
  SLH-DSA SHAKE-128F.
  `slhdsa_shake_128s`
  SLH-DSA SHAKE-128S.
  `slhdsa_shake_192f`
  SLH-DSA SHAKE-192F.
  `slhdsa_shake_192s`
  SLH-DSA SHAKE-192S.
  `slhdsa_shake_256f`
  SLH-DSA SHAKE-256F.
  `slhdsa_shake_256s`
  SLH-DSA SHAKE-256S.
  `sm2sig_sm3`
  SM2 with SM3.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Authentication`
  `getAuth()`
  Returns the authentication type for this scheme.
  `int`
  `getId()`
  Returns the numeric ID of this signature scheme.
  `static SignatureScheme`
  `valueOf(int schemeId)`
  Looks up a signature scheme by its numeric ID.
  `static SignatureScheme`
  `valueOf(String name)`
  Returns the enum constant of this type with the specified name.
  `static SignatureScheme[]`
  `values()`
  Returns an array containing the constants of this enum type, in the order they are declared.

  ### Methods inherited from class Enum

  `clone, compareTo, describeConstable, equals, finalize, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

  ### Methods inherited from class Object

  `getClass, notify, notifyAll, wait, wait, wait`

- ## Enum Constant Details

  - ### rsa_pkcs1_sha256

    public static final SignatureScheme rsa_pkcs1_sha256
    RSA with SHA-256 (PKCS1-v1_5).

  - ### rsa_pkcs1_sha384

    public static final SignatureScheme rsa_pkcs1_sha384
    RSA with SHA-384 (PKCS1-v1_5).

  - ### rsa_pkcs1_sha512

    public static final SignatureScheme rsa_pkcs1_sha512
    RSA with SHA-512 (PKCS1-v1_5).

  - ### ecdsa_secp256r1_sha256

    public static final SignatureScheme ecdsa_secp256r1_sha256
    ECDSA with P-256 and SHA-256.

  - ### ecdsa_secp384r1_sha384

    public static final SignatureScheme ecdsa_secp384r1_sha384
    ECDSA with P-384 and SHA-384.

  - ### ecdsa_secp521r1_sha512

    public static final SignatureScheme ecdsa_secp521r1_sha512
    ECDSA with P-521 and SHA-512.

  - ### rsa_pss_rsae_sha256

    public static final SignatureScheme rsa_pss_rsae_sha256
    RSA-PSS with RSA-E and SHA-256.

  - ### rsa_pss_rsae_sha384

    public static final SignatureScheme rsa_pss_rsae_sha384
    RSA-PSS with RSA-E and SHA-384.

  - ### rsa_pss_rsae_sha512

    public static final SignatureScheme rsa_pss_rsae_sha512
    RSA-PSS with RSA-E and SHA-512.

  - ### ed25519

    public static final SignatureScheme ed25519
    EdDSA with Ed25519.

  - ### ed448

    public static final SignatureScheme ed448
    EdDSA with Ed448.

  - ### rsa_pss_pss_sha256

    public static final SignatureScheme rsa_pss_pss_sha256
    RSA-PSS with SHA-256.

  - ### rsa_pss_pss_sha384

    public static final SignatureScheme rsa_pss_pss_sha384
    RSA-PSS with SHA-384.

  - ### rsa_pss_pss_sha512

    public static final SignatureScheme rsa_pss_pss_sha512
    RSA-PSS with SHA-512.

  - ### rsa_pkcs1_sha1

    public static final SignatureScheme rsa_pkcs1_sha1
    RSA with SHA-1 (PKCS1-v1_5, legacy).

  - ### ecdsa_sha1

    public static final SignatureScheme ecdsa_sha1
    ECDSA with SHA-1 (legacy).

  - ### mldsa44

    public static final SignatureScheme mldsa44
    ML-DSA level 2.

  - ### mldsa65

    public static final SignatureScheme mldsa65
    ML-DSA level 3.

  - ### mldsa87

    public static final SignatureScheme mldsa87
    ML-DSA level 5.

  - ### slhdsa_sha2_128s

    public static final SignatureScheme slhdsa_sha2_128s
    SLH-DSA SHA2-128S.

  - ### slhdsa_sha2_128f

    public static final SignatureScheme slhdsa_sha2_128f
    SLH-DSA SHA2-128F.

  - ### slhdsa_sha2_192s

    public static final SignatureScheme slhdsa_sha2_192s
    SLH-DSA SHA2-192S.

  - ### slhdsa_sha2_192f

    public static final SignatureScheme slhdsa_sha2_192f
    SLH-DSA SHA2-192F.

  - ### slhdsa_sha2_256s

    public static final SignatureScheme slhdsa_sha2_256s
    SLH-DSA SHA2-256S.

  - ### slhdsa_sha2_256f

    public static final SignatureScheme slhdsa_sha2_256f
    SLH-DSA SHA2-256F.

  - ### slhdsa_shake_128s

    public static final SignatureScheme slhdsa_shake_128s
    SLH-DSA SHAKE-128S.

  - ### slhdsa_shake_128f

    public static final SignatureScheme slhdsa_shake_128f
    SLH-DSA SHAKE-128F.

  - ### slhdsa_shake_192s

    public static final SignatureScheme slhdsa_shake_192s
    SLH-DSA SHAKE-192S.

  - ### slhdsa_shake_192f

    public static final SignatureScheme slhdsa_shake_192f
    SLH-DSA SHAKE-192F.

  - ### slhdsa_shake_256s

    public static final SignatureScheme slhdsa_shake_256s
    SLH-DSA SHAKE-256S.

  - ### slhdsa_shake_256f

    public static final SignatureScheme slhdsa_shake_256f
    SLH-DSA SHAKE-256F.

  - ### sm2sig_sm3

    public static final SignatureScheme sm2sig_sm3
    SM2 with SM3.

- ## Method Details

  - ### values

    public static SignatureScheme[] values()
    Returns an array containing the constants of this enum type, in the order they are declared.
    Returns:
      an array containing the constants of this enum type, in the order they are declared

  - ### valueOf

    public static SignatureScheme valueOf(String name)
    Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
    Parameters:
      `name` - the name of the enum constant to be returned.
    Returns:
      the enum constant with the specified name
    Throws:
      `IllegalArgumentException` - if this enum type has no constant with the specified name
      `NullPointerException` - if the argument is null

  - ### getId

    public int getId()
    Returns the numeric ID of this signature scheme.
    Returns:
      the ID

  - ### getAuth

    public Authentication getAuth()
    Returns the authentication type for this scheme.
    Returns:
      the authentication type

  - ### valueOf

    public static SignatureScheme valueOf(int schemeId)
    Looks up a signature scheme by its numeric ID.
    Parameters:
      `schemeId` - the numeric ID
    Returns:
      the signature scheme, or `null` if not found